/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { Series } from "./Series";
import { IHasCategoryModePreference_$type } from "./IHasCategoryModePreference";
import { Axis } from "./Axis";
import { DependencyProperty } from "igniteui-react-core";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { Point_$type, typeCast, Delegate_$type, markType, markDep } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { Thickness } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { Dictionary$2 } from "igniteui-react-core";
import { Pool$1 } from "igniteui-react-core";
import { AxisAnnotation } from "./AxisAnnotation";
import { SeriesView } from "./SeriesView";
import { NotImplementedException } from "igniteui-react-core";
import { AxisRange } from "./AxisRange";
import { NumericAxisBase } from "./NumericAxisBase";
import { AxisAnnotationFrame } from "./AxisAnnotationFrame";
import { ScalerParams } from "./ScalerParams";
import { CategoryXAxis } from "./CategoryXAxis";
import { AxisAnnotationFrameManager } from "./AxisAnnotationFrameManager";
import { PropertyMetadata } from "igniteui-react-core";
import { DeviceUtils } from "igniteui-react-core";
import { isNaN_, isInfinity } from "igniteui-react-core";
import { stringFormat } from "igniteui-react-core";
import { Path } from "igniteui-react-core";
/**
 * @hidden
 */
var ValueOverlay = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ValueOverlay, _super);
    function ValueOverlay() {
        var _this = _super.call(this) || this;
        _this.xd = 0;
        _this.xe = 0;
        _this.xa = 0;
        _this.wx = null;
        _this.w3 = null;
        _this.w2 = null;
        _this.ab = ValueOverlay.$;
        return _this;
    }
    ValueOverlay.prototype.bj = function () {
        return new ValueOverlay();
    };
    ValueOverlay.prototype.i5 = function (a, b, c) {
        return this.xf;
    };
    ValueOverlay.prototype.xb = function (a, b) {
        var c = Math.sqrt(Math.pow(a.x - b.x, 2) + Math.pow(a.y - b.y, 2));
        var d = Math.acos((a.x - b.x) / c);
        if ((a.y - b.y) < 0) {
            d = (2 * Math.PI) - d;
        }
        return d;
    };
    ValueOverlay.prototype.wa = function (a, b, c) {
        if (this.ww == null) {
            return { $type: Point_$type, x: NaN, y: NaN };
        }
        var d = this.xc();
        var e = NaN;
        var f = NaN;
        var g = NaN;
        var h = { $type: Point_$type, x: 0.5, y: 0.5 };
        var i = NaN;
        switch (this.ww.a2) {
            case 2:
                i = Math.sqrt(Math.pow(a.x - h.x, 2) + Math.pow(a.y - h.y, 2));
                g = d;
                e = h.x + Math.cos(g) * i;
                f = h.y + Math.sin(g) * i;
                f = this.cv.bx.top + this.cv.bx.height * (f - this.cv.by.top) / this.cv.by.height;
                e = this.cv.bx.left + this.cv.bx.width * (e - this.cv.by.left) / this.cv.by.width;
                break;
            case 0:
                e = d;
                f = a.y;
                f = this.cv.bx.top + this.cv.bx.height * (f - this.cv.by.top) / this.cv.by.height;
                break;
            case 1:
                f = d;
                e = a.x;
                e = this.cv.bx.left + this.cv.bx.width * (e - this.cv.by.left) / this.cv.by.width;
                break;
            case 3:
                g = this.xb(a, h);
                i = d;
                e = h.x + Math.cos(g) * i;
                f = h.y + Math.sin(g) * i;
                f = this.cv.bx.top + this.cv.bx.height * (f - this.cv.by.top) / this.cv.by.height;
                e = this.cv.bx.left + this.cv.bx.width * (e - this.cv.by.left) / this.cv.by.width;
                break;
        }
        return { $type: Point_$type, x: e, y: f };
    };
    ValueOverlay.prototype.j3 = function (a) {
        throw new NotImplementedException(0);
    };
    ValueOverlay.prototype.kn = function (a) {
        return this;
    };
    ValueOverlay.prototype.gd = function (a) {
        return false;
    };
    ValueOverlay.prototype.ay = function (a) {
        var b = typeCast(NumericAxisBase.$, a);
        var c = this.xf;
        if (isNaN_(c) || isInfinity(c)) {
            return null;
        }
        return new AxisRange(c, c);
    };
    ValueOverlay.prototype.rq = function (a) {
        this.o5(true, this.cv);
        if (!this.w1()) {
            if (this.wx != null) {
                this.xy(NaN, this.d3());
            }
            return;
        }
        if (this.gf(a)) {
            if (this.d3()) {
                if (this.dc.g) {
                    this.dc.t();
                }
                var b = this.xd;
                this.xd = this.xe;
                this.xe = b;
            }
            else {
                this.xd = this.xa;
            }
            this.xa = this.xc();
            this.r5();
        }
        else {
            this.xa = this.xc();
            this.xx(this.xa, this.wz);
        }
    };
    ValueOverlay.prototype.xc = function () {
        var a, b;
        var c = this.getViewInfo(b, a);
        b = c.p0;
        a = c.p1;
        var d = this.getEffectiveViewport1(this.cv);
        var e = new ScalerParams(0, a, b, this.ww.ch, d);
        return this.ww.el(this.xf, e);
    };
    ValueOverlay.prototype.xx = function (a, b) {
        if (this.ww == null) {
            return;
        }
        var c = typeCast(CategoryAxisBase.$, this.ww);
        if (c != null && !c.ce) {
            if (this.xf > c.lk - 1) {
                return;
            }
            if (c.categoryMode != 0) {
                var d = this.getEffectiveViewport1(b);
                var e = 0.5 * c.getCategorySize(b.by, b.bx, d);
                var f = false;
                if (c.cp && !c.ch) {
                    f = true;
                }
                if (typeCast(CategoryXAxis.$, c) !== null && c.ch) {
                    f = true;
                }
                if (f) {
                    e = -e;
                }
                a += e;
            }
        }
        var g = typeCast(NumericAxisBase.$, this.ww);
        if (g != null) {
            if (this.xf < g.l4 || this.xf > g.l3) {
                return;
            }
            if (g.lp && this.xf < 0) {
                return;
            }
        }
        var h;
        switch (this.ww.a2) {
            case 2:
            case 3:
                h = this.ww.j8(a, b.by, b.bx, this.getEffectiveViewport1(b), this.wh(b));
                break;
            default:
                h = this.ww.j8(a, b.by, b.bx, this.getEffectiveViewport1(b), this.wh(b));
                break;
        }
        if (h != null) {
            b.b1(h);
        }
        if (!b.q) {
            this.xy(a, this.d3());
        }
    };
    ValueOverlay.prototype.he = function (a, b, c) {
        var d = true;
        d = _super.prototype.he.call(this, a, b, c);
        if (!c.o() || b.isEmpty || a.isEmpty || this.ww == null || this.ww.bi == null) {
            d = false;
        }
        return d;
    };
    ValueOverlay.prototype.sp = function (a, b) {
        this.rp(false);
    };
    ValueOverlay.prototype.so = function (a, b) {
        this.rp(false);
    };
    ValueOverlay.prototype.pb = function (a, b, c, d) {
        throw new NotImplementedException(0);
    };
    ValueOverlay.prototype.q7 = function (a, b, c, d) {
        _super.prototype.q7.call(this, a, b, c, d);
        switch (b) {
            case ValueOverlay.$$p[11]:
                if (c != null) {
                    c.b0(this);
                }
                if (d != null) {
                    d.ct(this);
                }
                this.rp(false);
                this.qj();
                break;
            case "TransitionProgress":
                this.xe = this.xd + this.jq * (this.xa - this.xd);
                if (this.d5(this.cv)) {
                    return;
                }
                if (this.jq == 1) {
                    this.xx(this.xa, this.wz);
                    this.qm();
                }
                else {
                    this.xx(this.xe, this.wz);
                }
                if (this.db != null) {
                    this.db.qo(this);
                }
                break;
            case ValueOverlay.$$p[13]:
                var e = typeCast(NumericAxisBase.$, this.ww);
                if (e != null) {
                    e.c1();
                }
                this.rp(true);
                this.qk();
                break;
            case ValueOverlay.$$p[12]:
            case ValueOverlay.$$p[10]:
            case ValueOverlay.$$p[1]:
            case ValueOverlay.$$p[0]:
            case ValueOverlay.$$p[3]:
            case ValueOverlay.$$p[4]:
            case ValueOverlay.$$p[9]:
            case ValueOverlay.$$p[5]:
            case ValueOverlay.$$p[6]:
            case ValueOverlay.$$p[7]:
            case ValueOverlay.$$p[8]:
                this.rp(true);
                break;
        }
    };
    ValueOverlay.prototype.p9 = function () {
        _super.prototype.p9.call(this);
        if (this.ww != null) {
            this.ww.ib(false);
        }
    };
    ValueOverlay.prototype.o5 = function (a, b) {
        _super.prototype.o5.call(this, a, b);
        var c = b;
        c.b0();
    };
    ValueOverlay.prototype.w1 = function () {
        if (this.ww == null || this.ww.bi == null || isNaN_(this.xf) || this._visibility != 0) {
            return false;
        }
        var a = typeCast(CategoryAxisBase.$, this.ww);
        if (a != null && a.lk == 0) {
            return false;
        }
        return true;
    };
    ValueOverlay.prototype.preferredCategoryMode = function (a) {
        return 0;
    };
    Object.defineProperty(ValueOverlay.prototype, "categoryAxis", {
        get: function () {
            return typeCast(CategoryAxisBase.$, this.ww);
        },
        enumerable: false,
        configurable: true
    });
    ValueOverlay.prototype.cs = function () {
        return new ValueOverlayView(this);
    };
    ValueOverlay.prototype.qz = function (a) {
        _super.prototype.qz.call(this, a);
        this.wz = typeCast(ValueOverlayView.$, a);
    };
    ValueOverlay.prototype.rr = function (a, b) {
        _super.prototype.rr.call(this, a, b);
        if (!this.g0) {
            this.cv.a4(b);
            return;
        }
        this.cv.a4(b);
        if (this.d5(this.cu) || !this.w1()) {
            return;
        }
        var c = this.getEffectiveViewport1(this.cv);
        var d = this.ww.el(this.xf, new ScalerParams(0, this.cu.by, a, this.ww.ch, c));
        this.xx(d, typeCast(ValueOverlayView.$, this.cu));
        this.g0 = false;
    };
    ValueOverlay.prototype.getOffsetValue = function () {
        return 0;
    };
    ValueOverlay.prototype.getCategoryWidth = function () {
        return 0;
    };
    Object.defineProperty(ValueOverlay.prototype, "yg", {
        get: function () {
            return new Thickness(1, this.w6, this.w8, this.w7, this.w5);
        },
        enumerable: false,
        configurable: true
    });
    ValueOverlay.prototype.ai = function () {
        return [this.ww];
    };
    ValueOverlay.prototype.xy = function (a, b) {
        if (isNaN_(a)) {
            if (this.wx != null) {
                AxisAnnotationFrameManager.b(this.wx);
                AxisAnnotationFrameManager.d(this, this.wx, true, this.w2, this.w3, b, this.xg, this.xg, this.wy, this.wy);
            }
            return;
        }
        var c = false;
        if (this.w2 == null) {
            c = true;
            this.w3 = new List$1(Axis.$, 0);
            this.w2 = new Dictionary$2(Axis.$, Pool$1.$.specialize(AxisAnnotation.$), 0);
        }
        this.wx = new AxisAnnotationFrame();
        var d = this.u7;
        if (d == null) {
            d = this.vd;
        }
        var e = this.ww.cp;
        AxisAnnotationFrameManager.c(this.wx, { $type: Point_$type, x: a, y: a }, this, this.db, this.getEffectiveViewport(), d, this.yd, this.w4, this.yf, this.ye, this.yg, this.w9, this.yd, this.w4, this.yf, this.ye, this.yg, this.w9, !e && this.w0, e && this.w0);
        AxisAnnotationFrameManager.d(this, this.wx, c, this.w2, this.w3, b, this.xg, this.xg, this.wy, this.wy);
    };
    ValueOverlay.prototype.get_isValueOverlay = function () {
        return true;
    };
    ValueOverlay.prototype.xt = function (a) {
        if (this.ww != null) {
            return this.ww.gf(a);
        }
        return null;
    };
    Object.defineProperty(ValueOverlay.prototype, "xv", {
        get: function () {
            var a = this.xt(this.xf);
            return a != null ? a : stringFormat("{0:0.##}", this.xf);
        },
        enumerable: false,
        configurable: true
    });
    ValueOverlay.$t = markType(ValueOverlay, 'ValueOverlay', Series.$, [IHasCategoryModePreference_$type]);
    ValueOverlay.$$p = markDep(DependencyProperty, PropertyMetadata, ValueOverlay, 'raisePropertyChanged', ['AxisAnnotationBackgroundCornerRadius:w4:xz', [1, DeviceUtils.g(3)], 'AxisAnnotationBackground:yd:x0', [Brush.$, null], 'AxisAnnotationFormatLabel:wy:x1', [Delegate_$type], 'AxisAnnotationInterpolatedValuePrecision:xg:x2', [1, -1], 'AxisAnnotationOutline:ye:x3', [Brush.$, null], 'AxisAnnotationPaddingBottom:w5:x4', [1, NaN], 'AxisAnnotationPaddingLeft:w6:x5', [1, NaN], 'AxisAnnotationPaddingRight:w7:x6', [1, NaN], 'AxisAnnotationPaddingTop:w8:x7', [1, NaN], 'AxisAnnotationStrokeThickness:w9:x8', [1, NaN], 'AxisAnnotationTextColor:yf:x9', [Brush.$, null], 'Axis:ww:ya', [Axis.$, null], 'IsAxisAnnotationEnabled:w0:yb', [0, false], 'Value:xf:yc', [1, 0]]);
    return ValueOverlay;
}(Series));
export { ValueOverlay };
/**
 * @hidden
 */
var ValueOverlayView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ValueOverlayView, _super);
    function ValueOverlayView(a) {
        var _this = _super.call(this, a) || this;
        _this.b2 = null;
        _this.b2 = new Path();
        return _this;
    }
    ValueOverlayView.prototype.bd = function () {
        _super.prototype.bd.call(this);
        this.b2._stroke = this.e.u7;
        this.b2.ad = this.e.ie;
        this.b2.ai = this.e.v0;
        this.b2.aj = this.e.v1;
    };
    ValueOverlayView.prototype.be = function () {
        _super.prototype.be.call(this);
        var a = this.br();
        this.b2._stroke = a;
        this.b2.ad = this.e.ie + 3;
        this.b2._stroke = a;
        this.b2.ad = this.e.ie + 3;
    };
    ValueOverlayView.prototype.b1 = function (a) {
        this.b2.an = a;
        this.as();
    };
    ValueOverlayView.prototype.b0 = function () {
        this.b2.an = null;
        this.as();
    };
    ValueOverlayView.prototype.a8 = function (a, b) {
        _super.prototype.a8.call(this, a, b);
        if (a.d) {
            a.t(this.b2);
        }
    };
    ValueOverlayView.prototype.an = function (a) {
        _super.prototype.an.call(this, a);
        this.e.bc.exportPathData(a, this.b2, "ValueOverlayPath", []);
    };
    ValueOverlayView.$t = markType(ValueOverlayView, 'ValueOverlayView', SeriesView.$);
    return ValueOverlayView;
}(SeriesView));
export { ValueOverlayView };
